using System.Text.Json.Serialization;
using Luski.net.Enums;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes.Public;

public class SocketUser : IncomingHTTP
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; internal set; } = default!;
    [JsonInclude]
    [JsonPropertyName("displayname")]
    public string DisplayName { get; internal set; } = default!;
    [JsonInclude]
    [JsonPropertyName("selected_channel")]
    public long SelectedChannel { get; internal set; } = default!;
    [JsonInclude]
    [JsonPropertyName("status")]
    public UserStatus Status { get; internal set; } = default!;
    [JsonInclude]
    [JsonPropertyName("picture_type")]
    public PictureType PictureType { get; internal set; } = default!;
    [JsonInclude] 
    [JsonPropertyName("roles")]
    public long[] RoleIds { get; internal set; } = default!;
    [JsonInclude]
    [JsonPropertyName("username")]
    public string Username { get; internal set; } = default!;
}

[JsonSerializable(typeof(SocketUser))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class PublicSocketUserContext : JsonSerializerContext
{

}