using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Luski.net.Interfaces;

namespace Luski.net.JsonTypes;

public class UserKeyGetRequest : IWebRequest
{
    public long id { get; set; }
    public long owner { get; set; }
    public EncryptionType encryption_type { get; set; }
    public string key_data { get; set; }
}

[JsonSerializable(typeof(UserKeyGetRequest))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class UserKeyGetRequestContext : JsonSerializerContext
{

}